#Goodness-of-fit using test statistic based on ML for the skewed normal dist:

#Model: yi=b1*xi+b2*x^{2}_i+vi+ei where v_i~SN(0,A,alpha) and ei~N(0,Di)
#where yi:sample survey of 4-person median income in yr 1989.
#xi:census 4-person median income in yr 1979. 

rm(list=ls(all=TRUE))

#---------------
# square-root-inverse of a matrix
mat.sqrt.inv<-function(A)
{
  ei<-eigen(A)
  d<-ei$values
  d<-(d+abs(d))/2
  d2<-1 / sqrt(d)
  d2[d == 0]<-0
  ans<-ei$vectors %*% diag(d2) %*% t(ei$vectors)
  return(ans)
}
################################
library(sae)
library(nlme)
library(MASS)
library(psych)
library(sn)

m=51  
p1=2   #number of regression coefficents: beta1,beta2
p=3    #number of model parameters: beta1,beta2,A
d=1    #alpha parameter
q=p+d


Median<-read.table("fmedn89-1.txt",header=TRUE)
attach(Median)

yib<-rep(0,m)
D<-rep(0,m)
xi<-rep(0,m)

bb<-0
for(i in 1:m){
  yib[i]<-X4Med[13+bb]
  D[i]<-(X4_SE[13+bb])^2
  bb<-bb+13
}
yib
D
SD<-sqrt(D)

dd<-0
for(i in 1:m){xi[i]<-X4Med[2+dd]
dd<-dd+13}
xi

X<-cbind(xi,xi^2)
###################################
  PX<-X%*% solve(t(X)%*%X)%*%t(X)
  PXI<-diag(1,m)-PX
  D1<-diag(SD^2)
  #################Tailoring APPROACH######################
  
  #####We use the following estimtors (based on the PR and EBLUE) as initial values for 
  #the tailoring approach:
  
  A.hat.tem<-(t(yib)%*%PXI%*%yib-tr(PXI%*%D1))/(m-p1)
  A.hat.tem
  #[1,] 18818686
  sumx.tem<-matrix(0,p1,p1)
  sumy.tem<-matrix(0,p1,1)
  for(i in 1:m){
    sumx.tem<-sumx.tem+( X[i,]%*%t(X[i,] ) ) /drop(A.hat.tem+D[i]) 
    sumy.tem<-sumy.tem+( X[i,]*yib[i] )/drop(A.hat.tem+D[i])
  }
  BETA.hat.tem<-solve(sumx.tem)%*%sumy.tem
  BETA.hat.tem
  #xi  2.0686457882
  #-0.0000126125
  ############################################
  #dat.ran=data.frame(xi=xi, yib=yib, m=m, p1=p1, p=p, d=d, D=D)
 ##################Test statistic based on residulas (using PR estimates)####################
  sumx.tem<-matrix(0,p1,p1)
  for(i in 1:m){
    sumx.tem<-sumx.tem+(1/m)*( X[i,]%*%t(X[i,] ) ) /drop(A.hat.tem+D[i]) 
  }
  
  V.beta.hat<-solve(sumx.tem) #using PR (beta estimate)
  
  tem4<-rep(0,p1)
  tem3<-0
  for(i in 1:m){
    tem3<-tem3+(1/m)*(D[i])/(D[i]+A.hat.tem)
    tem4<-tem4+t(X[i,])*drop((1/m)*(SD[i]/(D[i]+A.hat.tem)))
  }
  V1.TM<-drop(tem3) 
  V2.TM<-tem4%*%V.beta.hat%*%t(tem4)
  V.Tm<-V1.TM-V2.TM
  V.Tm<-ifelse(V.Tm<=0,0.0001,V.Tm)
  
  Tm.hat<-0
  for(i in 1:m){
    Tm.hat<-Tm.hat+(1/m)*(yib[i]-X[i,]%*%BETA.hat.tem)*(SD[i]/(D[i]+A.hat.tem))
  }
  Tm.HAT<-Tm.hat
  Z.2<-m*Tm.hat^2/V.Tm
  Z.2
  # [1,] 1.762026
  #since 1.76<3.84 so, we can't reject the H0:vi~N(0,A)
##################################################################################