#Goodness-of-fit using test statistic based on F for the skewed normal dist:

#Model: yi=b1*xi+vi+ei where v_i~SN(0,A,alpha) and ei~N(0,Di)
#m=50

rm(list=ls(all=TRUE))

#---------------
runif(1)
seed<-.Random.seed[1]
set.seed(seed, kind ="default")

library(sae)
library(nlme)
library(MASS)
library(psych)
library(sn)

m=50
p1=1   #number of regression coefficents: beta1
p=2   #number of model parameters: beta1,A
d=1  #alpha parameter
q=p+d

n=m/2

Di.a=runif(n,3.5,4.5)
Di.b=runif(n,3.5,4.5)
D<-c(Di.a, Di.b)

SD<-sqrt(D)

beta1.a=1
beta1.b=1 #3

A=10

xi<-runif(m,0,1)

R=5000


V1.TM<-rep(0,R)
V2.TM<-rep(0,R)
Tm.HAT<-rep(0,R)
Z.2<-rep(0,R)
BETA.HAT.PR<-matrix(0,R,p1)
A.HAT.PR<-rep(0,R)

NUM.IT<-rep(0,R)

for(r in 1:R){
  yib<-rep(0,m)
  for(i in 1:n){
     yib[i]<-rsn(1, beta1.a*xi[i], omega=sqrt(A+D[i]), alpha=0, tau=0,  dp=NULL)
  }
  for(i in (n+1):m){
       yib[i]<-rsn(1, beta1.b*xi[i], omega=sqrt(A+D[i]), alpha=0, tau=0,  dp=NULL)
  }
  X<-cbind(xi)
  ###################################
  PX<-X%*% solve(t(X)%*%X)%*%t(X)
  PXI<-diag(1,m)-PX
  D1<-diag(SD^2)
  #################Tailoring APPROACH######################
  #####We use the following estimtors (based on the PR and EBLUE) as initial values for 
  #the tailoring approach:
  
  A.hat.tem<-(t(yib)%*%PXI%*%yib-tr(PXI%*%D1))/(m-p1)
  A.HAT.PR[r]<-A.hat.tem  
  A.hat.tem<-ifelse(A.hat.tem<=0,0.0001,A.hat.tem)
  
  sumx.tem<-matrix(0,p1,p1)
  sumy.tem<-matrix(0,p1,1)
  for(i in 1:m){
    sumx.tem<-sumx.tem+( X[i,]%*%t(X[i,] ) ) /drop(A.hat.tem+D[i]) 
    sumy.tem<-sumy.tem+( X[i,]*yib[i] )/drop(A.hat.tem+D[i])
  }
  BETA.hat.tem<-solve(sumx.tem)%*%sumy.tem
  BETA.HAT.PR[r,]<-BETA.hat.tem
  ############################################
   sumx.tem<-matrix(0,p1,p1)
 for(i in 1:m){
    sumx.tem<-sumx.tem+(1/m)*( X[i,]%*%t(X[i,] ) ) /drop(A.hat.tem+D[i]) 
  }
  
  V.beta.hat<-solve(sumx.tem) #using PR (beta estimate)
  
  tem4<-rep(0,p1)
  tem3<-0
  for(i in 1:m){
    tem3<-tem3+(1/m)*(D[i])/(D[i]+A.hat.tem)
    tem4<-tem4+t(X[i,])*drop((1/m)*(SD[i]/(D[i]+A.hat.tem)))
  }
  V1.TM[r]<-drop(tem3) 
  V2.TM[r]<-tem4%*%V.beta.hat%*%t(tem4)
  V.Tm<-V1.TM[r]-V2.TM[r]
  V.Tm<-ifelse(V.Tm<=0,0.0001,V.Tm)
  
  Tm.hat<-0
  for(i in 1:m){
    Tm.hat<-Tm.hat+(1/m)*(yib[i]-X[i,]%*%BETA.hat.tem)*(SD[i]/(D[i]+A.hat.tem))
  }
  Tm.HAT[r]<-Tm.hat
  Z.2[r]<-m*Tm.hat^2/V.Tm
  
  cat(r)
}#loop R
#=========================
summary(Z.2)
var(Z.2)

summary(V1.TM)
summary(V2.TM)
summary(Tm.HAT)
var(Tm.HAT)


summary(A.HAT.PR)
summary(BETA.HAT.PR)

Z.2.new<-NULL

a<-1
for(r in 1:R){
  if(NUM.IT[r]<1){
  Z.2.new[a]<-Z.2[r]
  a<-a+1
  }
}
a-1
summary(Z.2.new)
###################################################################################################
P.value.Z2.alpha0.01<-0
P.value.Z2.alpha0.05<-0
P.value.Z2.alpha0.1<-0
for(r in 1:(a-1)){
  if(Z.2.new[r]>6.63){P.value.Z2.alpha0.01<-P.value.Z2.alpha0.01+1} #d=1

  if(Z.2.new[r]>3.84){P.value.Z2.alpha0.05<-P.value.Z2.alpha0.05+1} #d=1

  if(Z.2.new[r]>2.70){P.value.Z2.alpha0.1<-P.value.Z2.alpha0.1+1} #d=1
}
P.value.Z2.alpha0.01/(a-1)
P.value.Z2.alpha0.05/(a-1)
P.value.Z2.alpha0.1/(a-1)

###############################################SIMULAITON STUDY (POWER)########################################################
#Model:yi=b1*xi+vi+ei where vi~SN(0,A,alpha)

#alpha=0.5

Tm.HAT<-rep(0,R)
Z.2<-rep(0,R)
             
for(r in 1:R){
  yib<-rep(0,m)
  for(i in 1:n){
    yib[i]<-rsn(1, beta1.a*xi[i], omega=sqrt(A+D[i]), alpha=0.5, tau=0,  dp=NULL)
  }
  for(i in (n+1):m){
    yib[i]<-rsn(1, beta1.b*xi[i], omega=sqrt(A+D[i]), alpha=0.5, tau=0,  dp=NULL)
  }
 ################Test statistic based on residulas (using PR estimates)###################
  BETA.hat<-BETA.HAT.PR[r,]
  A.hat<-A.HAT.PR[r]
  A.hat<-ifelse(A.hat<=0,0.0001,A.hat)
  
  sumx.tem<-matrix(0,p1,p1)
  for(i in 1:m){
    sumx.tem<-sumx.tem+(1/m)*( X[i,]%*%t(X[i,] ) ) /drop(A.hat+SD[i]^2) 
  }
  
  V.beta.hat<-solve(sumx.tem) #using PR (beta estimate)
  
  tem4<-rep(0,p1)
  tem3<-0
  for(i in 1:m){
    tem3<-tem3+(1/m)*(SD[i]^2)/(SD[i]^2+A.hat)
    tem4<-tem4+t(X[i,])*drop((1/m)*(SD[i]/(SD[i]^2+A.hat)))
  }
  V.Tm<-drop(tem3-tem4%*%V.beta.hat%*%t(tem4))
  V.Tm<-ifelse(V.Tm<=0,0.0001,V.Tm)
  
  Tm.hat<-0
  for(i in 1:m){
    Tm.hat<-Tm.hat+(1/m)*(yib[i]-X[i,]%*%BETA.hat)*(SD[i]/(SD[i]^2+A.hat))
  }
  Tm.HAT[r]<-Tm.hat
  Z.2[r]<-m*Tm.hat^2/V.Tm
  
  cat(r)
}#loop R

summary(Z.2)
summary(Tm.HAT)

Z.2.new<-NULL

a<-1
for(r in 1:R){
  if(NUM.IT[r]<1){
    Z.2.new[a]<-Z.2[r]
    a<-a+1
  }
}
a-1
summary(Z.2.new)

######################################################################################################################
Power.Z2.alpha0.01<-0
Power.Z2.alpha0.05<-0
Power.Z2.alpha0.1<-0
for(r in 1:(a-1)){
    if(Z.2.new[r]>6.63){Power.Z2.alpha0.01<-Power.Z2.alpha0.01+1}  #df=1

    if(Z.2.new[r]>3.84){Power.Z2.alpha0.05<-Power.Z2.alpha0.05+1}  #df=1

    if(Z.2.new[r]>2.70){Power.Z2.alpha0.1<-Power.Z2.alpha0.1+1}  #df=1
}
Power.Z2.alpha0.01/(a-1)
Power.Z2.alpha0.05/(a-1)
Power.Z2.alpha0.1/(a-1)

########################################################################################################################
