#23 Jan 2018
#Goodness-of-fit using test statistic based on chi-square result of Jinag (2001):

#Model: yi=b1*xi+vi+ei
#m=50

rm(list=ls(all=TRUE))

#---------------
runif(1)
seed<-.Random.seed[1]
set.seed(seed, kind ="default")

library(sae)
library(nlme)
library(MASS)
library(psych)
library(sn)
#library(integrate)

m=50
p=1 #number of regression coefficents: beta1
M=round(max(p+2,m^(0.2)))
Nk=round(m/M)

n=m/2

#beta0.c=1
#beta0.d=1

Di.a=runif(n,3.5,4.5)
Di.b=runif(n,3.5,4.5)

D<-c(Di.a, Di.b)
SD<-sqrt(D)

beta1.a=1
beta1.b=1 #3

A=10 

xi<-runif(m,0,1) 
X<-cbind(xi)
PX<-X%*% solve(t(X)%*%X)%*%t(X)
PXI<-diag(1,m)-PX
D1<-diag(SD^2)
####################################
B=5000
B1=1000

Chi.2.alpha0.01<-rep(0,B)
Chi.2.alpha0.05<-rep(0,B)
Chi.2.alpha0.10<-rep(0,B)

BETA.HAT.PR<-matrix(0,B,p)
A.HAT.PR<-rep(0,B)

for(b in 1:B){
  
  yib<-rep(0,m)
  for(i in 1:n){
    yib[i]<-rsn(1, beta1.a*xi[i], omega=sqrt(A+D[i]), alpha=0, tau=0,  dp=NULL)
  }
  for(i in (n+1):m){
    yib[i]<-rsn(1, beta1.b*xi[i], omega=sqrt(A+D[i]), alpha=0, tau=0,  dp=NULL)
  }
  #####We use the the PR and EBLUE##############
  A.hat.pr<-(t(yib)%*%PXI%*%yib-tr(PXI%*%D1))/(m-p)
  A.HAT.PR[b]<-A.hat.pr  
  A.hat.pr<-ifelse(A.hat.pr<=0,0.0001,A.hat.pr)
  
  sumx.tem<-matrix(0,p,p)
  sumy.tem<-matrix(0,p,1)
  for(i in 1:m){
    sumx.tem<-sumx.tem+( X[i,]%*%t(X[i,] ) ) /drop(A.hat.pr+SD[i]^2) 
    sumy.tem<-sumy.tem+( X[i,]*yib[i] )/drop(A.hat.pr+SD[i]^2)
  }
  BETA.hat<-solve(sumx.tem)%*%sumy.tem
  BETA.HAT.PR[b,]<-BETA.hat
  ############################################
  ysort<-sort(yib)
  c1=ysort[round(m/4)]
  c2=ysort[round(m/2)]
  c3=ysort[round(3*m/4)]
  C<-c(c1,c2,c3)
  Phi<-matrix(0,M,m)
  
  for(i in 1:m){
    tem<-(C[1]-X[i,]%*%BETA.hat)/sqrt(A.hat.pr+SD[i])
    Phi[1,i]<-pnorm(tem, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
  }
  
  for(k in 2:(M-1)){
    for(i in 1:m){
      temk<-(C[k]-X[i,]%*%BETA.hat)/sqrt(A.hat.pr+SD[i])
      temk1<-(C[k-1]-X[i,]%*%BETA.hat)/sqrt(A.hat.pr+SD[i])
      Phi[k,i]<-pnorm(temk, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)-pnorm(temk1, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
    }
  }
  
  
  for(i in 1:m){
    tem<-(C[M-1]-X[i,]%*%BETA.hat)/sqrt(A.hat.pr+SD[i])
    Phi[M,i]<-1-pnorm(tem, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
  }
  
  P<-rep(0,M)
  for(k in 1:M){
    for(i in 1:m){
      P[k]<-P[k]+Phi[k,i]
    }
  }
  
  ChiSq.bp<-(1/m)*sum((Nk-P)^2)
  ##################Bootstrap loop#######################
  ChiSq.bp.boot<-rep(0,B1)
  for(b1 in 1:B1){
    
    random1<-rnorm(m,0,1)
    random2<-rnorm(m,0,1)
    yib<-rep(0,m)
    for(i in 1:m){
      yib[i]<-BETA.hat*xi[i]+sqrt(A.hat.pr)*random1[i]+SD[i]*random2[i]
    }
    
    A.hat.boot<-(t(yib)%*%PXI%*%yib-tr(PXI%*%D1))/(m-p)
    A.hat.boot<-ifelse(A.hat.boot<=0,0.0001,A.hat.boot)
    
    sumx<-matrix(0,p,p)
    sumy<-matrix(0,p,1)
    for(i in 1:m){
      sumx<-sumx+( X[i,]%*%t(X[i,] ) ) /drop(A.hat.boot+SD[i]^2) 
      sumy<-sumy+( X[i,]*yib[i] )/drop(A.hat.boot+SD[i]^2)
    }
    BETA.hat.boot<-solve(sumx)%*%sumy
    
    ysort<-sort(yib)
    c1=ysort[round(m/4)]
    c2=ysort[round(m/2)]
    c3=ysort[round(3*m/4)]
    C<-c(c1,c2,c3)
    Phi<-matrix(0,M,m)
    
    for(i in 1:m){
      tem<-(C[1]-X[i,]%*%BETA.hat.boot)/sqrt(A.hat.boot+SD[i])
      Phi[1,i]<-pnorm(tem, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
    }
    
    for(k in 2:(M-1)){
      for(i in 1:m){
        temk<-(C[k]-X[i,]%*%BETA.hat.boot)/sqrt(A.hat.boot+SD[i])
        temk1<-(C[k-1]-X[i,]%*%BETA.hat.boot)/sqrt(A.hat.boot+SD[i])
        Phi[k,i]<-pnorm(temk, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)-pnorm(temk1, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
      }
    }
    
    
    for(i in 1:m){
      tem<-(C[M-1]-X[i,]%*%BETA.hat.boot)/sqrt(A.hat.boot+SD[i])
      Phi[M,i]<-1-pnorm(tem, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
    }
    
    P<-rep(0,M)
    for(k in 1:M){
      for(i in 1:m){
        P[k]<-P[k]+Phi[k,i]
      }
    }
    
    
    ChiSq.bp.boot[b1]<-(1/m)*sum((Nk-P)^2)
  }#loop of B1
  #======================
  tem.alpha.01<-quantile(ChiSq.bp.boot, probs = c(0.99))
  Chi.2.alpha0.01[b]<-ifelse(ChiSq.bp>tem.alpha.01,1,0)
  
  
  tem.alpha.05<-quantile(ChiSq.bp.boot, probs = c(0.95))
  Chi.2.alpha0.05[b]<-ifelse(ChiSq.bp>tem.alpha.05,1,0)
  
  tem.alpha.10<-quantile(ChiSq.bp.boot, probs = c(0.90))
  Chi.2.alpha0.10[b]<-ifelse(ChiSq.bp>tem.alpha.10,1,0)
  
  
  cat(b)
}#loop of B
#####################################################
summary(A.HAT.PR)
summary(BETA.HAT.PR)

p.value.chi2.alpha0.01<-mean(Chi.2.alpha0.01)
p.value.chi2.alpha0.01

p.value.chi2.alpha0.05<-mean(Chi.2.alpha0.05)
p.value.chi2.alpha0.05

p.value.chi2.alpha0.10<-mean(Chi.2.alpha0.10)
p.value.chi2.alpha0.10
####################################################################################################################################SIMULAITON STUDY (POWER)########################################################
#Model:yi=b1*xi+vi+ei  &  vi~ SN(0,A,alpha=0.5)

#gamma=1

Chi.2.01<-rep(0,B)
Chi.2.05<-rep(0,B)
Chi.2.10<-rep(0,B)


for(b in 1:B){
  
  yib<-rep(0,m)
  for(i in 1:n){
    yib[i]<-rsn(1, beta1.a*xi[i], omega=sqrt(A+D[i]), alpha=0.5, tau=0,  dp=NULL)
  }
  for(i in (n+1):m){
    yib[i]<-rsn(1, beta1.b*xi[i], omega=sqrt(A+D[i]), alpha=0.5, tau=0,  dp=NULL)
  }
  ################Chi-squared test statistic based on PR estimates###################
  BETA.hat<-BETA.HAT.PR[b,]
  A.hat.pr<-A.HAT.PR[b]
  A.hat.pr<-ifelse(A.hat.pr<=0,0.0001,A.hat.pr)
  ############################################
  ysort<-sort(yib)
  c1=ysort[round(m/4)]
  c2=ysort[round(m/2)]
  c3=ysort[round(3*m/4)]
  C<-c(c1,c2,c3)
  Phi<-matrix(0,M,m)
  
  for(i in 1:m){
    tem<-(C[1]-X[i,]%*%BETA.hat)/sqrt(A.hat.pr+SD[i])
    Phi[1,i]<-pnorm(tem, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
  }
  
  for(k in 2:(M-1)){
    for(i in 1:m){
      temk<-(C[k]-X[i,]%*%BETA.hat)/sqrt(A.hat.pr+SD[i])
      temk1<-(C[k-1]-X[i,]%*%BETA.hat)/sqrt(A.hat.pr+SD[i])
      Phi[k,i]<-pnorm(temk, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)-pnorm(temk1, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
    }
  }
  
  
  for(i in 1:m){
    tem<-(C[M-1]-X[i,]%*%BETA.hat)/sqrt(A.hat.pr+SD[i])
    Phi[M,i]<-1-pnorm(tem, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
  }
  
  P<-rep(0,M)
  for(k in 1:M){
    for(i in 1:m){
      P[k]<-P[k]+Phi[k,i]
    }
  }
  
  ChiSq.bp<-(1/m)*sum((Nk-P)^2)
  ##########################We also need to estimate the model parameters from incorrect model to use for the bootstrap approach#############
  p1=1
  X1<-cbind(X)
  PX1<-X1%*% solve(t(X1)%*%X1)%*%t(X1)
  PXI1<-diag(1,m)-PX1
  
  A.hat.tem<-(t(yib)%*%PXI1%*%yib-tr(PXI1%*%D1))/(m-p1)
  A.hat.tem<-ifelse(A.hat.tem<=0,0.0001,A.hat.tem)
  
  sumx<-matrix(0,p1,p1)
  sumy<-matrix(0,p1,1)
  for(i in 1:m){
    sumx<-sumx+( X1[i,]%*%t(X1[i,] ) ) /drop(A.hat.tem+SD[i]^2) 
    sumy<-sumy+( X1[i,]*yib[i] )/drop(A.hat.tem+SD[i]^2)
  }
  BETA.hat.tem<-solve(sumx)%*%sumy
  ##################################################Bootstrap loop#######################
  ChiSq.bp.boot<-rep(0,B1)
  for(b1 in 1:B1){
    
    yib<-rep(0,m)
    for(i in 1:n){
      yib[i]<-rsn(1, BETA.hat.tem[1]*xi[i], omega=sqrt(A.hat.tem+D[i]), alpha=0.5, tau=0,  dp=NULL)
    }
    for(i in (n+1):m){
      yib[i]<-rsn(1, BETA.hat.tem[1]*xi[i], omega=sqrt(A.hat.tem+D[i]), alpha=0.5, tau=0,  dp=NULL)
    }
    
    A.hat.boot<-(t(yib)%*%PXI%*%yib-tr(PXI%*%D1))/(m-p)
    A.hat.boot<-ifelse(A.hat.boot<=0,0.0001,A.hat.boot)
    
    sumx<-matrix(0,p,p)
    sumy<-matrix(0,p,1)
    for(i in 1:m){
      sumx<-sumx+( X[i,]%*%t(X[i,] ) ) /drop(A.hat.boot+SD[i]^2) 
      sumy<-sumy+( X[i,]*yib[i] )/drop(A.hat.boot+SD[i]^2)
    }
    BETA.hat.boot<-solve(sumx)%*%sumy
    
    ysort<-sort(yib)
    c1=ysort[round(m/4)]
    c2=ysort[round(m/2)]
    c3=ysort[round(3*m/4)]
    C<-c(c1,c2,c3)
    Phi<-matrix(0,M,m)
    
    for(i in 1:m){
      tem<-(C[1]-X[i,]%*%BETA.hat.boot)/sqrt(A.hat.boot+SD[i])
      Phi[1,i]<-pnorm(tem, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
    }
    
    for(k in 2:(M-1)){
      for(i in 1:m){
        temk<-(C[k]-X[i,]%*%BETA.hat.boot)/sqrt(A.hat.boot+SD[i])
        temk1<-(C[k-1]-X[i,]%*%BETA.hat.boot)/sqrt(A.hat.boot+SD[i])
        Phi[k,i]<-pnorm(temk, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)-pnorm(temk1, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
      }
    }
    
    
    for(i in 1:m){
      tem<-(C[M-1]-X[i,]%*%BETA.hat.boot)/sqrt(A.hat.boot+SD[i])
      Phi[M,i]<-1-pnorm(tem, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
    }
    
    P<-rep(0,M)
    for(k in 1:M){
      for(i in 1:m){
        P[k]<-P[k]+Phi[k,i]
      }
    }
    
    
    ChiSq.bp.boot[b1]<-(1/m)*sum((Nk-P)^2)
  }#loop of B1
  #======================
  tem.01<-quantile(ChiSq.bp.boot, probs = c(0.99))
  Chi.2.01[b]<-ifelse(ChiSq.bp>tem.01,1,0)
  
  tem.05<-quantile(ChiSq.bp.boot, probs = c(0.95))
  Chi.2.05[b]<-ifelse(ChiSq.bp>tem.05,1,0)
  
  tem.10<-quantile(ChiSq.bp.boot, probs = c(0.90))
  Chi.2.10[b]<-ifelse(ChiSq.bp>tem.10,1,0)
  
  cat(b)
}#loop of B
#####################################################
Power.01<-mean(Chi.2.01)
Power.01


Power.05<-mean(Chi.2.05)
Power.05

Power.10<-mean(Chi.2.10)
Power.10
#####################################################